#!/usr/bin/env sh
# First Parameter = Input File
# Second Parameter = Output Filename
# Other Parameters = Other GFit Parameters

# This skript can be seen as a black-box capsulating the execution of GFit. 
# First the Input Tracefile is converted, then GFit is executed, finally the 
# result is converted into the standart XML-Map format.

# ATTENTION: Skript must be executed directly from its directory

INPUT=$1
OUTPUT=$2
shift
shift

# Read directories and filenames
SCRIPTDIR="../scripts/"
TRACEFILE=`${SCRIPTDIR}EchoRefFileNameFromXML.tcl "$INPUT"`

# Create link to trace file in G-Fit directory
\rm -f "local.trace"
\ln -f -s "$TRACEFILE" "local.trace"

# Execute G-Fit
./gfit "local.trace" $@

# Create XML Output
`${SCRIPTDIR}GFitToXMLMap.tcl "gfit.result" "${OUTPUT}"`

# Remove local output
\rm -f local.trace
\rm -f gfit.result

