#!/usr/bin/env sh
# First Parameter = Input Trace Filename
# Second Parameter = Input Filename PH distribution
# Third Parameter = Output filename
# Fourth Parameters = Number of autocorrelation coefficients

INPUT1=$1
INPUT2=$2
OUTPUT=$3
ACORRS=$4

# Read directories and filenames
SCRIPTDIR="../scripts/"
TRACEFILE=`${SCRIPTDIR}EchoRefFileNameFromXML.tcl "$INPUT1"`

# Create link to trace file in Momfit directory
\rm -f "local.trace"
\ln -f -s "$TRACEFILE" "local.trace"

cp -f "$INPUT2" "local.xml"

# Analyze trace file to determine lag-k autocorrelation
./modan.exe -trace=local.trace -traceformat=1 -moments=1 -jointmoments=1 -autocorrelation=${ACORRS} -output=1
\rm -f local.jmoments local.aweights local.moments local.jweights local.weights

# Convert input PH distribution
`${SCRIPTDIR}XMLToPH.tcl "local.xml" "local.d0_out" "local.lambda_out" "local.pi_out"`
# Execute Momtrans
./Momtrans local
# Execute ACfit
./acorrfit.exe local

# Create XML Output
`${SCRIPTDIR}MAPToXML.tcl "local.map_acorr" "${OUTPUT}"`

# Remove local output
\rm -f local.trace
\rm -f local.d0_out local.pi_out local.lambda_out local.d0_mom local.acorr local.pi_mom local.map_jmom

