#!/usr/bin/env sh
# 1st Parameter = Input Trace Filename
# 2nd Parameter = Output Filename 
# 3rd Parameter = Number of Generation
# 4th Parameter = alpha value
# 5th Parameter = Mu value
# 6th Parameter = Lambda value
# 7th Parameter = Epsilon value
# 8th Parameter = Number of Iterations
# 9th Parameter = Dimension
# 10th Parameter = Another alpha value
# 11th Parameter = Seed
# 12th Parameter = Autocorrelation

INPUT=$1
OUTPUT=$2
MAXGEN=$3
ALPHA=$4
MU=$5
LAMBDA=$6
EPSILON=$7
ITER=$8
DIM=$9
ALPHA2=${10}
SEED=${11}
ACOV=${12}

shift
shift
shift
shift
shift
shift
shift
shift
shift
shift
shift
shift


# Read directories and filenames
SCRIPTDIR="../scripts/"
TRACEFILE=`${SCRIPTDIR}EchoRefFileNameFromXML.tcl "$INPUT"`

# Create link to trace file in Mapmoea directory
\rm -f "local.trace"
\ln -f -s "$TRACEFILE" "local.trace"

#create Files in local Directory and write values into it

#first write into the spea2_param.txt file
echo "seed $SEED" >> spea2_param.txt
echo "tournament 2" >> spea2_param.txt

#second , the <prefix.PISAparam> File
echo "seed $SEED" >> local.PISAparam
echo "maxgen $MAXGEN" >> local.PISAparam
echo "outputdir front" >> local.PISAparam
echo "outputfile PISA_front.txt" >> local.PISAparam

#and then the PISA_cfg File
echo "alpha $ALPHA" >> PISA_cfg
echo "mu $MU" >> PISA_cfg
echo "lambda $LAMBDA" >> PISA_cfg
echo "dim 2" >> PISA_cfg

#AusfÃ¼hrung der Tools
./spea2 spea2_param.txt PISA_ 0.5 &
./pdfphpisamap.exe local -i $ITER -e $EPSILON -n $DIM -alpha $ALPHA2 -lsmin -3 -lsmax 2 -pdf 1 -acov $ACOV


#create XML output
`${SCRIPTDIR}EMToXMLMap.tcl "local.map_out" "${OUTPUT}"`

# Remove local output
\rm -f local.trace

