#!/usr/bin/env sh
# First Parameter = Input File
# Second Parameter = Output File

# This script embeds a trace-file into the standard XML-Trace-format and 
# amends the value count if not already listed.

# Read Parameter
TRACEFILE="$1"

# Remove Outputfile, if it already exists
\rm -f "$2"

# Determine Linecount and read firstline of trace-file (which might already contain the value count).
FIRSTLINESTRING=`head -n 1 "$1"`
LINECOUNT=`wc "$1" | awk '{print $1;}'`

# Checks if the first line of the input file is the number of the data samples.
# If not, a new file containing the number in its first line is created.
# otherwise the original trace file is used/copied.
VALUECOUNT=`expr $LINECOUNT - 1`
if [ "$VALUECOUNT" != "$FIRSTLINESTRING" ];
     then
   	VALUECOUNT=$LINECOUNT
        if [ "$1" != "$2.trace" ];
          then
	     echo $VALUECOUNT > "$2.trace"
	     \cat "$1" >> "$2.trace"
          else
             # Insert VALUECOUNT at first line
	     sed -i "1s/.*$/$VALUECOUNT\n&/g" "$2.trace"
          fi
	TRACEFILE="$2.trace"
     else
        if [ "$1" != "$2.trace" ];
          then
             \cp "$1" "$2.trace"
          fi
        TRACEFILE="$2.trace"
fi

# Create actual XML-File
echo "<profido>" > "$2"
echo "<file>" >> "$2"
echo "<ref>${TRACEFILE}</ref>" >> "$2"
echo "<type>XML-Trace</type>" >> "$2"
echo "<valuecount>${VALUECOUNT}</valuecount>" >> "$2"
echo "</file>" >> "$2"
echo "</profido>" >> "$2"

