#!/usr/bin/env wish

proc xml_to_capp {infile_xml outfile_capp} {
	set in_xml [open $infile_xml]
	set xml_desc ""
	while {![eof $in_xml]} {
		set xml_desc "$xml_desc \n[gets $in_xml]"
	}
	set states ""
	set capp_xml_desc ""
	set chep_xml_desc ""
	set temp ""
	regexp {<capp>(.*)</capp>} $xml_desc temp capp_xml_desc
	regexp {<chep>(.*)</chep>} $xml_desc temp chep_xml_desc
	# ARMA base process
	set arcoef ""
	set macoef ""
	set arorder ""
	set maorder ""
	set arvariance ""
	set arma_xml_desc ""
	# CHEP
	set herd_prob ""
	set herd_rates ""
	set herd_phases ""
	# CAPP
	set acph_d0 ""
	set acph_pi ""
	if {$chep_xml_desc != ""} {
		regexp {<prob>(.*)</prob>} $chep_xml_desc temp herd_prob
		regexp {<phases>(.*)</phases>} $chep_xml_desc temp herd_phases
		regexp {<rates>(.*)</rates>} $chep_xml_desc temp herd_rates
		regexp {<arima>(.*)</arima>} $chep_xml_desc temp arma_xml_desc
	} else {
		regexp {<pi>(.*)</pi>} $capp_xml_desc temp acph_pi
		regexp {<d0>(.*)</d0>} $capp_xml_desc temp acph_d0
		regexp {<arima>(.*)</arima>} $capp_xml_desc temp arma_xml_desc
	}
	regexp {<ar>(.*)</ar>} $arma_xml_desc temp arcoef
	regexp {<arcount>(.*)</arcount>} $arma_xml_desc temp arorder
	regexp {<ma>(.*)</ma>} $arma_xml_desc temp macoef
	regexp {<macount>(.*)</macount>} $arma_xml_desc temp maorder
	regexp {<variance>(.*)</variance>} $arma_xml_desc temp arvariance
	set outc [open $outfile_capp w+]
	if {$chep_xml_desc != ""} {
		puts $outc "model = chep"
		puts $outc "distribution = hypererlang"
		puts $outc "phases = $herd_phases"
		puts $outc "rates = $herd_rates"
		puts $outc "prob = $herd_prob"
	} else {
		puts $outc "model = capp"
		puts $outc "T = $acph_d0"
		puts $outc "tau = $acph_pi"
	}
	puts $outc "order = $arorder, $maorder"
	if {$arcoef != ""} {
		puts $outc "ar = $arcoef"
	}
	if {$macoef != ""} {
		puts $outc "ma = $macoef"
	}
	puts $outc "arma_mean = 0.0"
	puts $outc "arma_variance = $arvariance"
	close $in_xml
	close $outc
}

##################################################################################
##################################################################################
##################################################################################

# This script converts a XML description of a CAPP/CHEP into the format for plot
set infile ""
set outfile ""
set infile [lindex $argv 0]
set outfile [lindex $argv 1]
xml_to_capp $infile $outfile
exit

