#!/usr/bin/env wish

proc xmlmap_to_mapem_input {infile outfile} {
	set inf [open $infile r]
	set content [read $inf]
	close $inf

	#XML-Datei zu einer Tcl Liste parsen
	set parsedc [xml2list $content]
	if {[lindex $parsedc 0] != "profido"} {
		puts "Input file is not a ProFiDo XML description!"
		exit
	}
	set found 0
	foreach parsed [lindex $parsedc 2] {
		if {[lindex $parsed 0] == "map"} {
			set found 1
			set mapTag [lindex $parsed 2]
			set d0 ""
			set d1 ""
			set states ""

			foreach curTag $mapTag {
				if {[lindex $curTag 0] == "states"} {
					set states  [lindex [lindex [lindex $curTag 2] 0] 1]
				} else {
					if {[lindex $curTag 0] == "d0"} {
						set d0  [lindex [lindex [lindex $curTag 2] 0] 1]
					} else {
						if {[lindex $curTag 0] == "d1"} {
							set d1  [lindex [lindex [lindex $curTag 2] 0] 1]
						}
					}
				}
			}

			# Überprüfen ob wir ein gültiges Ergebnis haben
			if {($d0!="") && ($d1!="")} {
				set outf [open $outfile w+]
				puts $outf 2
				puts $outf 1
				puts $outf 0
				puts $outf $states
                        
				set laenge [llength $d0]
			
				set count 0
				set anzahlAusgabe $states
				set diag 0
				while {$count < $laenge} {
					for {set i $count} {$i < [expr $count+$states]} {incr i} {
						if {([lindex $d0 $i] <= 0)} {set anzahlAusgabe [expr $anzahlAusgabe-1]}
						if {([lindex $d0 $i] < 0)} {set diag [lindex $d0 $i]}
					}

					puts $outf "$anzahlAusgabe $diag"

					for {set i $count} {$i < [expr $count+$states]} {incr i} {
						if {([lindex $d0 $i] > 0)} {
							set element [lindex $d0 $i]
							set k [expr $i % $states]
							puts $outf "$k $element" 
						}
					}
	
					set count [expr $count + $states]
					set anzahlAusgabe $states
				} 

				set count 0
				set anzahlAusgabe $states
				while {$count < $laenge} {
					for {set i $count} {$i < [expr $count+$states]} {incr i} {
						if {([lindex $d1 $i] <= 0)} {set anzahlAusgabe [expr $anzahlAusgabe-1]}
					}

					puts $outf "$anzahlAusgabe"

					for {set i $count} {$i < [expr $count+$states]} {incr i} {
						if {([lindex $d1 $i] > 0)} {
							set element [lindex $d1 $i]
							set k [expr $i % $states]
							puts $outf "$k $element" 
						}
					}
	
					set count [expr $count + $states]
					set anzahlAusgabe $states
				} 

			} else {
				puts "Fehler ! Datei $infile enthält keine gültige Information"
			}
		}
	}
	if {$found == 0} {
		puts "Error: File $infile does not contain map informations."
	}
}

# This methode parses an XML-File into a tcl-list. 
# This code was copied from the TCL-WiKi (http://wiki.tcl.tk/)

proc xml2list xml {
     regsub -all {>\s*<} [string trim $xml " \n\t<>"] "\} \{" xml
     set xml [string map {> "\} \{#text \{" < "\}\} \{"}  $xml]

     set res ""   ;# string to collect the result
     set stack {} ;# track open tags
     set rest {}
     foreach item "{$xml}" {
        ## Ignore XML-comments
         if {[string range $item 0 0] != "?"} {
                switch -regexp -- $item {
                ^# {append res "{[lrange $item 0 end]} " ; #text item}
                ^/ {
                        regexp {/(.+)} $item -> tagname ;# end tag
                        set expected [lindex $stack end]
                        if {$tagname!=$expected} {error "$item != $expected"}
                         set stack [lrange $stack 0 end-1]
                        append res "\}\} "
                }
                /$ { # singleton - start and end in one <> group
                regexp {([^ ]+)( (.+))?/$} $item -> tagname - rest
                set rest [lrange [string map {= " "} $rest] 0 end]
                append res "{$tagname [list $rest] {}} "
                }
                default {
                set tagname [lindex $item 0] ;# start tag
                set rest [lrange [string map {= " "} $item] 1 end]
                lappend stack $tagname
                append res "\{$tagname [list $rest] \{"
                }
                }
                if {[llength $rest]%2} {error "att's not paired: $rest"}
                }
        }


     if [llength $stack] {error "unresolved: $stack"}
     string map {"\} \}" "\}\}"} [lindex $res 0]
}

set infile ""
set outfile ""
set infile [lindex $argv 0]
set outfile [lindex $argv 1]
xmlmap_to_mapem_input $infile $outfile
exit

