#!/usr/bin/env wish

proc xml_to_ph {infile_xml outfile_d0 outfile_lambda outfile_pi} {
	set in_xml [open $infile_xml]
	set xml_desc ""
	while {![eof $in_xml]} {
		set xml_desc "$xml_desc [gets $in_xml]"
	}
	set states ""
	set d0 ""
	set pi ""
	regexp {<ph>(.*)</ph>} $xml_desc ph ph_xml_desc
	regexp {<states>(.*)</states>} $ph_xml_desc ph states
	regexp {<d0>(.*)</d0>} $ph_xml_desc ph d0
	regexp {<pi>(.*)</pi>} $ph_xml_desc ph pi
	set out_d0 [open $outfile_d0 w+]
	set out_lambda [open $outfile_lambda w+]
	set out_pi [open $outfile_pi w+]
	puts $out_pi "$states"
	puts $out_lambda "$states"
	puts $out_d0 "1\n\n0\n$states\n"
	for {set i 0} {$i < $states} {incr i} {
		set counter 0
		set row ""
		for {set j 0} {$j < $states} {incr j} {
			if {$i!=$j} {
				if {[lindex $d0 [expr $i*$states+$j]] != 0} {
					set row "$row\n$j [lindex $d0 [expr $i*$states+$j]]"
					incr counter
				}
			}
		}
		puts $out_d0 "$counter [lindex $d0 [expr $i*$states+$i]] $row"
		puts $out_pi "[lindex $pi $i]"
		puts $out_lambda "[expr (-1)*[lindex $d0 [expr $i*$states+$i]]]"
	}
	close $in_xml
	close $out_d0
	close $out_lambda
	close $out_pi
}

##################################################################################
##################################################################################
##################################################################################

# This script converts a XML description of a PH distribution into the sparse 
# matrix format for JMomfit 
set infile ""
set outfile1 ""
set outfile2 ""
set outfile3 ""
set infile [lindex $argv 0]
set outfile1 [lindex $argv 1]
set outfile2 [lindex $argv 2]
set outfile3 [lindex $argv 3]
xml_to_ph $infile $outfile1 $outfile2 $outfile3
exit

