#!/bin/sh
# -----------------------------
# Export of workflow: batch
# -----------------------------

# This workflow was created with ProFiDo 1.2


# Before any further steps, check if all required external binaries are present in the path.
requirements="sh wish Rscript"
missingCommands=""
for curCmd in $requirements; do
	if ! [ `command -v $curCmd` ]; then
		missingCommands="$missingCommands\n$curCmd"
	fi
done
if ! [ -z "$missingCommands" ]; then
	echo "Warning, the following required external commands were not found on your system.\nPlease ensure their presence before executing the workflow.$missingCommands"
fi

# Before the workflow can be used, this script sets up the environment.

# First, all folders are set.
export SOFTWARESOURCE="${HOME}/ProFiDo/software"
export TARGETDIR="/home/gerloff/cvsshk/profido/rsc/export_samples"


# If no parameter was passed, remove old Folders
if [ -z "$1" ]; then 
		\rm -f -R ${TARGETDIR}/Results/
		\rm -f -R ${TARGETDIR}/Software/
fi


# Creater Folders
\mkdir -p "${TARGETDIR}/Results/"
\mkdir -p "${TARGETDIR}/Software/"

# Copy Software
\cp -f -R "${SOFTWARESOURCE}/Gfit" "${TARGETDIR}/Software/Gfit"
\cp -f -R "${SOFTWARESOURCE}/EM" "${TARGETDIR}/Software/EM"
\cp -f -R "${SOFTWARESOURCE}/momfit" "${TARGETDIR}/Software/momfit"
\cp -f -R "${SOFTWARESOURCE}/jmomfit" "${TARGETDIR}/Software/jmomfit"
\cp -f -R "${SOFTWARESOURCE}/arimafit" "${TARGETDIR}/Software/arimafit"
\cp -f -R "${SOFTWARESOURCE}/Plot" "${TARGETDIR}/Software/Plot"
\cp -f -R "${SOFTWARESOURCE}/scripts" "${TARGETDIR}/Software"
